
#ifndef HH_UC_HANDLER
#define HH_UC_HANDLER

#include "flow_handler.hh"

#include <cctype>

#include <sys/socket.h>

class uc_handler : public flow_handler {
public:
    uc_handler(init_context& ctxt, bool plumb = true) : flow_handler(ctxt, plumb) {
    }

    bool avail(flow_handler *h, data d) {
	ts_debug_2("in uc_handler avail");

	string uc = d;
	for (string::iterator i = uc.begin(); i != uc.end(); ++i)
	    *i = tolower(*i);

	ts_debug_2(" - received <<%s>>", uc.c_str());

	return upstream->avail(this, uc);
    }

    int write(data d) {
	ts_debug_2("uc_handler-write");

	string uc = d;
	for (string::iterator i = uc.begin(); i != uc.end(); ++i)
	    *i = toupper(*i);

	return downstream[0]->write(uc);
    }

    DECLARE_HANDLER;
};

#endif
